{
  inputs = {
    home-manager = {
      url = "github:nix-community/home-manager/release-23.11";
      inputs.nixpkgs.follows = "nixpkgs";
    };
    nixpkgs = {
      url = "github:nixos/nixpkgs/nixos-23.11";
    };
    nixpkgs-unstable = {
      url = "github:nixos/nixpkgs/nixos-unstable";
    };
    flake-utils = {
      url = "github:numtide/flake-utils";
    };
  };
  outputs = inputs: {
    nixosConfigurations = {
      w1n5t0n = import ./machines/w1n5t0n.nix inputs;
      morpheus = import ./machines/morpheus.nix inputs;
    };
    homeConfigurations = {
      me = inputs.home-manager.lib.homeManagerConfiguration {
        system = "x86_64-linux";
        username = "me";
        homeDirectory = "/home/me";
        extraSpecialArgs = {
          inherit inputs;
          system = "x86_64-linux";
          hostname = "w1n5t0n";
        };
        configuration.imports = [ ./users/me.nix ];
      };
    };
  }
  //
  inputs.flake-utils.lib.eachDefaultSystem (system:
    let pkgs = import inputs.nixpkgs {
      inherit system;
    };
    in
    {
      devShell = pkgs.mkShell {
        packages = with pkgs; [
          inputs.home-manager.defaultPackage.${system}
        ];
      };
    }
  );
}
